OGRE-Next: Ogre::TextureGpuListener Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
Ogre::TextureGpuListener Class Referenceabstract
Core » Resources

`#include <OgreTextureGpuListener.h>`

Inheritance diagram for Ogre::TextureGpuListener:
[legend]

## Public Types
enum | Reason { Unknown , FromStorageToSysRam , FromSysRamToStorage , GainedResidency , LostResidency , PoolTextureSlotChanged , ResidentToSysRamSync , MetadataCacheOutOfDate , ExceptionThrown , FsaaSettingAlteredByApi , ReadyForRendering , Deleted }

## Public Member Functions
virtual | ~TextureGpuListener ()
virtual void | notifyTextureChanged (TextureGpu *texture, TextureGpuListener::Reason reason, void *extraData)=0
| Called when a TextureGpu changed in a way that affects how it is displayed:
virtual bool | shouldStayLoaded (TextureGpu *texture)
| Return true if this TextureGpu should likely stay loaded or else graphical changes could occur.

## Member Enumeration Documentation

## ◆ Reason

enum Ogre::TextureGpuListener::Reason

Enumerator
Unknown |
FromStorageToSysRam | OnStorage -> OnSystemRam.
FromSysRamToStorage | OnSystemRam -> OnStorage.
GainedResidency | OnStorage -> Resident OnSystemRam -> Resident See ReadyForRendering.
LostResidency | Resident -> OnStorage Resident -> OnSystemRam.
PoolTextureSlotChanged |
ResidentToSysRamSync | Only called while TextureGpu is still Resident, and strategy is AlwaysKeepSystemRamCopy. This listener happens when something was done to the TextureGpu that modifies its contents in the GPU, and were thus forced to sync those values back to SystemRam. This listener calls tells that sync is over.
MetadataCacheOutOfDate | The Metadata cache was out of date and we had to do a ping-pong. Expect this to be followed by at least LostResidency and GainedResidency calls This is very important, because if you were expecting certain sequence of calls (e.g. you were expecting a LostResidency soon to arrive), expect that to be changed. See TextureGpuManager for details about the metadata cache.
ExceptionThrown | Called when the worker thread caught an exception. This exception has already been logged, and the texture resumed loading normally with a white 2x2 RGBA8 fallback. This listener will get called from the main thread. The texture may still have pending residency transitions (e.g. it may still be loading the 2x2 fallback) Cast Exception e = reinterpret_cast<Exception>( extraData ); to know more info
FsaaSettingAlteredByApi | Requested FSAA (MSAA / CSAA / EQAA / etc) is not supported by the API, and thus the setting had to be downgraded. Note this may happen on device lost, and a new GPU became in use; thus it's possible for a TextureGpu to initially support certain FSAA but later change.
ReadyForRendering | This Reason is called when TextureGpu::notifyDataIsReady is called. This normally means worker thread is done loading texture from file and uploading it to GPU; and can now be used for rendering. It does NOT mean that Ogre has finished issueing rendering commands to a RenderTexture and is now ready to be presented to the monitor.
Deleted |

## Constructor & Destructor Documentation

## ◆ ~TextureGpuListener()

virtual Ogre::TextureGpuListener::~TextureGpuListener | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ notifyTextureChanged()

virtual void Ogre::TextureGpuListener::notifyTextureChanged | ( | TextureGpu * | texture,
|  | TextureGpuListener::Reason | reason,
|  | void * | extraData )
| pure virtual

Called when a TextureGpu changed in a way that affects how it is displayed:

1. TextureGpu::notifyDataIsReady got called (texture is ready to be displayed)
2. Texture changed residency status.
3. Texture is being deleted. It won't be a valid pointer after this call.

Implemented in Ogre::AsyncTextureTicket, Ogre::CompositorPassUav, Ogre::Decal, Ogre::DefaultTextureGpuManagerListener, Ogre::Font, Ogre::HlmsComputeJob, Ogre::Light, and Ogre::TextureGpuManager.

## ◆ shouldStayLoaded()

virtual bool Ogre::TextureGpuListener::shouldStayLoaded | ( | TextureGpu * | texture | ) |
| inlinevirtual

Return true if this TextureGpu should likely stay loaded or else graphical changes could occur.

Return false if it is certainly safe to unload.

References OGRE_UNUSED_VAR.

The documentation for this class was generated from the following file:

- OgreTextureGpuListener.h